# Copyright (c) 2012-2025, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***


from . import AWSObject, AWSProperty, PropsDictType, Tags
from .validators import boolean, integer


class InternalAccessAnalysisRuleCriteria(AWSProperty):
    """
    `InternalAccessAnalysisRuleCriteria <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-internalaccessanalysisrulecriteria.html>`__
    """

    props: PropsDictType = {
        "AccountIds": ([str], False),
        "ResourceArns": ([str], False),
        "ResourceTypes": ([str], False),
    }


class InternalAccessAnalysisRule(AWSProperty):
    """
    `InternalAccessAnalysisRule <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-internalaccessanalysisrule.html>`__
    """

    props: PropsDictType = {
        "Inclusions": ([InternalAccessAnalysisRuleCriteria], False),
    }


class InternalAccessConfiguration(AWSProperty):
    """
    `InternalAccessConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-internalaccessconfiguration.html>`__
    """

    props: PropsDictType = {
        "InternalAccessAnalysisRule": (InternalAccessAnalysisRule, False),
    }


class AnalysisRuleCriteria(AWSProperty):
    """
    `AnalysisRuleCriteria <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-analysisrulecriteria.html>`__
    """

    props: PropsDictType = {
        "AccountIds": ([str], False),
        "ResourceTags": (dict, False),
    }


class AnalysisRule(AWSProperty):
    """
    `AnalysisRule <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-analysisrule.html>`__
    """

    props: PropsDictType = {
        "Exclusions": ([AnalysisRuleCriteria], False),
    }


class UnusedAccessConfiguration(AWSProperty):
    """
    `UnusedAccessConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-unusedaccessconfiguration.html>`__
    """

    props: PropsDictType = {
        "AnalysisRule": (AnalysisRule, False),
        "UnusedAccessAge": (integer, False),
    }


class AnalyzerConfiguration(AWSProperty):
    """
    `AnalyzerConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-analyzerconfiguration.html>`__
    """

    props: PropsDictType = {
        "InternalAccessConfiguration": (InternalAccessConfiguration, False),
        "UnusedAccessConfiguration": (UnusedAccessConfiguration, False),
    }


class Filter(AWSProperty):
    """
    `Filter <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-filter.html>`__
    """

    props: PropsDictType = {
        "Contains": ([str], False),
        "Eq": ([str], False),
        "Exists": (boolean, False),
        "Neq": ([str], False),
        "Property": (str, True),
    }


class ArchiveRule(AWSProperty):
    """
    `ArchiveRule <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-accessanalyzer-analyzer-archiverule.html>`__
    """

    props: PropsDictType = {
        "Filter": ([Filter], True),
        "RuleName": (str, True),
    }


class Analyzer(AWSObject):
    """
    `Analyzer <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-accessanalyzer-analyzer.html>`__
    """

    resource_type = "AWS::AccessAnalyzer::Analyzer"

    props: PropsDictType = {
        "AnalyzerConfiguration": (AnalyzerConfiguration, False),
        "AnalyzerName": (str, False),
        "ArchiveRules": ([ArchiveRule], False),
        "Tags": (Tags, False),
        "Type": (str, True),
    }
